' PRINST.BAS -- written for Quick Basic 4.5
'  This program writes printer information into PRSET.EXE
'  When you run this program, PRSET.EXE should be in the default
'  directory.
DEFINT A-Z

DECLARE FUNCTION HexView$ (Num%)
DECLARE SUB EditLine (Num%)
DECLARE SUB DisplayAndModify ()
DECLARE SUB SaveFile ()
DECLARE SUB OpenFile ()
DECLARE SUB FindID ()

CONST FALSE = 0
CONST TRUE = NOT FALSE
CONST ID$ = "PRINTER OPTIONS:"      'Identification string in PRSet.Exe
CONST FileName$ = "PRSET.EXE"

DIM SHARED InfoLoc&, Marker$, Choices, MesgLen, CodeLen
REDIM SHARED Msg$(1), Code$(1)
Marker$ = SPACE$(LEN(ID$) + 3)

OpenFile
FindID
DisplayAndModify
SaveFile
END

ErrorTrap:
   CLS
   PRINT "File "; FileName$; " not found in the default directory"
   END

SUB DisplayAndModify        'Display current info & let user change it
   Choices = ASC(MID$(Marker$, LEN(ID$) + 1))
   MesgLen = ASC(MID$(Marker$, LEN(ID$) + 2))
   CodeLen = ASC(MID$(Marker$, LEN(ID$) + 3))
   IF Choices <= 0 OR MesgLen <= 0 OR CodeLen <= 0 THEN
      PRINT "PRSET.EXE has been corrupted."
      END
   END IF
   REDIM Msg$(1 TO Choices), Code$(1 TO Choices)
   SEEK #1, InfoLoc&
   FOR Lp = 1 TO Choices
      Msg$(Lp) = SPACE$(MesgLen)
      Code$(Lp) = SPACE$(CodeLen)
      GET #1, , Msg$(Lp)
      GET #1, , Code$(Lp)
      Header$ = CHR$(ASC("A") - 1 + Lp) + ". "
      MID$(Msg$(Lp), 1, 3) = Header$
   NEXT Lp
   DO
      CLS
      PRINT "PC Resource's Printer Setup Utility -- Printer Commands"
      PRINT
      FOR Lp = 1 TO Choices
         PRINT TAB(4); Msg$(Lp);
         FOR Lp2 = 1 TO ASC(Code$(Lp))
            PRINT HexView$(ASC(MID$(Code$(Lp), Lp2 + 1, 1)));
         NEXT Lp2
         PRINT
      NEXT Lp
      LOCATE Choices + 4, 1
      PRINT "Press Letter of command to change or ESC to quit";
      A$ = UCASE$(INPUT$(1))
      IF A$ >= "A" AND A$ <= CHR$(ASC("A") - 1 + Choices) THEN
         EditLine (ASC(A$) - ASC("A") + 1)
      END IF
   LOOP UNTIL A$ = CHR$(27)
END SUB

SUB EditLine (Num%)
   Current$ = SPACE$(MesgLen - 3)
   CLS
   LSET Current$ = MID$(Msg$(Num), 4, MesgLen - 3)
   PRINT "Current Text: "; Current$
   PRINT
   PRINT "Type new text or press ENTER to leave text unchanged"
   PRINT : PRINT "          ==> ";
   LINE INPUT Temp$
   IF LEN(Temp$) THEN
      LSET Current$ = Temp$
      MID$(Msg$(Num%), 4) = Current$ + CHR$(0)
   END IF
   PRINT
   Current$ = SPACE$(CodeLen)
   CurSize = ASC(Code$(Num))
   PRINT "Current printer codes: ";
   IF CurSize > 0 THEN
      FOR Lp = 2 TO CurSize + 1
         PRINT HexView$(ASC(MID$(Code$(Num), Lp, 1)));
      NEXT Lp
   ELSE
      PRINT "None";
   END IF
   PRINT : PRINT
   PRINT "Enter new codes as hexadecimal numbers separated by spaces"
   PRINT "or simply press ENTER to leave the codes unchanged."
   PRINT "To erase all codes, type 'NONE'"
   PRINT
   PRINT "                   ==> ";
   LINE INPUT Temp$
   Temp$ = RTRIM$(LTRIM$(Temp$))
   IF UCASE$(Temp$) = "NONE" THEN
      MID$(Code$(Num), 1, 1) = CHR$(0)
   ELSEIF LEN(Temp$) THEN
      Count = 1
      DO WHILE LEN(Temp$) AND Count < CodeLen
         SpacePosn = INSTR(Temp$, " ")
         IF SpacePosn > 0 THEN
            NewCode$ = "&H" + LEFT$(Temp$, SpacePosn - 1)
            Temp$ = MID$(Temp$, SpacePosn + 1)
         ELSE
            NewCode$ = "&H" + Temp$
            Temp$ = ""
         END IF
         Count = Count + 1
         MID$(Code$(Num), Count, 1) = CHR$(VAL(NewCode$))
      LOOP
      MID$(Code$(Num), 1, 1) = CHR$(Count - 1)
   END IF
END SUB

SUB FindID
   Last& = LOF(1)
   Posn& = 1
   DO
      IF Posn& >= Last& THEN
         PRINT "PRSET.EXE has been packed or corrupted"
         END
      END IF
      SEEK #1, Posn&
      GET #1, , Marker$
      Posn& = Posn& + 16
   LOOP UNTIL INSTR(Marker$, ID$) = 1
   InfoLoc& = SEEK(1)
END SUB

FUNCTION HexView$ (Num%)      'Returns 2-char string plus space
   IF Num > &HFF OR Num < 0 THEN
      PRINT "Error in HexView input!": END
   END IF
   Result$ = HEX$(Num%)
   WHILE LEN(Result$) < 2
      Result$ = "0" + Result$
   WEND
   HexView$ = Result$ + " "
END FUNCTION

SUB OpenFile
   ON ERROR GOTO ErrorTrap
   OPEN FileName$ FOR BINARY AS #1
   ON ERROR GOTO 0
END SUB

SUB SaveFile
   CLS
   PRINT "Save Changes (y/n) ==> ";
   DO
      CH$ = UCASE$(INPUT$(1))
   LOOP UNTIL INSTR("YN", CH$)
   IF CH$ = "Y" THEN
      SEEK #1, InfoLoc&
      FOR Lp = 1 TO Choices
         IF LEN(Msg$(Lp)) <> MesgLen THEN
            PRINT "Message"; Lp; " has been corrupted"
            END
         END IF
         MID$(Msg$(Lp), MesgLen, 1) = CHR$(0)
         IF LEN(Code$(Lp)) <> CodeLen THEN
            PRINT "Codeset"; Lp; "has been corrupted"
            END
         END IF
         PUT #1, , Msg$(Lp)
         PUT #1, , Code$(Lp)
      NEXT Lp
      CLS
      PRINT
      PRINT "PRSET.EXE has been updated.  You must reboot your computer"
      PRINT "and run PRSET to see the changes in the program."
   ELSE
      CLS
      PRINT "PRSET.EXE was NOT modified."
   END IF
   CLOSE #1
END SUB

